# -*- coding: utf-8 -*-

# Form implementation generated from reading ui file 'intline.ui'
#
# Created: Fri Jun 15 14:37:13 2007
#      by: PyQt4 UI code generator 4.1
#
# WARNING! All changes made in this file will be lost!

import sys
import openbabel

from PyQt4 import QtCore, QtGui
from cclib.parser import ccopen
from cclib.bridge import makeopenbabel

from intmodel import *
from glwidget import *

LENGTH, ANGLE, TORSION = range(3)
types = ["LENGTH", "ANGLE", "TORSION"]

class CustomComboBox(QtGui.QComboBox):
    def __init__(self, parent = None):
        QtGui.QComboBox.__init__(self, parent)
        
        QtCore.QObject.connect(self, QtCore.SIGNAL("activated(int)"), self.slotActivated)
        QtCore.QObject.connect(self, QtCore.SIGNAL("highlighted(int)"), self.slotHighlighted)

    def slotActivated(self, i):
        self.emit(QtCore.SIGNAL("activatedPlus(int, int)"), self.index, i)

    def slotHighlighted(self, i):
        self.emit(QtCore.SIGNAL("highlightedPlus(int, int, int)"), self.index, self.type, i)

    def enterEvent(self, event):
        self.emit(QtCore.SIGNAL("signalSelectType(int, int)"), self.index, self.type)

    def leaveEvent(self, event):
        self.emit(QtCore.SIGNAL("signalDeselect()"))

class CustomSpinBox(QtGui.QDoubleSpinBox):
    def __init__(self, parent = None):
        QtGui.QDoubleSpinBox.__init__(self, parent)
        self.setFocusPolicy(QtCore.Qt.StrongFocus)
        
        QtCore.QObject.connect(self, QtCore.SIGNAL("valueChanged(double)"), self.slotValueChanged)

    def enterEvent(self, event):
        self.emit(QtCore.SIGNAL("signalSelectType(int, int)"), self.index, self.type)

    def leaveEvent(self, event):
        self.emit(QtCore.SIGNAL("signalDeselect()"))
        
    def wheelEvent(self, event):
        event.ignore()

    def slotValueChanged(self, val):
        self.emit(QtCore.SIGNAL("valueChangedPlus(int, int, double)"), self.index, self.type, val)

class Molecule(QtGui.QWidget):
    def __init__(self, parent = None):
        QtGui.QWidget.__init__(self, parent)

        self.gridLayout = QtGui.QGridLayout(self)
        
        self.elements = []
        self.lengthLabels = []
        self.lengthValues = []
        self.angleLabels = []
        self.angleValues = []
        self.torsionLabels = []
        self.torsionValues = []

        self.matrix = []
        self.obmol = None
        self.isSetup = False

    def setup(self, size):

        for i in range(size):
            
            number = QtGui.QLabel("%i."%(i+1))
            self.gridLayout.addWidget(number, i, 0)

            element = QtGui.QLineEdit(self)
            element.resize(50,30)
            element.index = i
            self.gridLayout.addWidget(element, i, 1)
            self.elements.append(element)

            if i == 0:
                continue

            lengthLabel = CustomComboBox(self)
            lengthLabel.index = i
            lengthLabel.type = LENGTH
            QtCore.QObject.connect(lengthLabel, QtCore.SIGNAL("activatedPlus(int, int)"), \
                                    self.slotUpdateLength)
            QtCore.QObject.connect(lengthLabel, QtCore.SIGNAL("highlightedPlus(int, int, int)"), \
                                    self.slotHighlight)
            QtCore.QObject.connect(lengthLabel, QtCore.SIGNAL("signalSelectType(int, int)"), \
                                    self.slotSelectType)
            QtCore.QObject.connect(lengthLabel, QtCore.SIGNAL("signalDeselect()"), \
                                    self.slotDeselect)

            self.lengthLabels.append(lengthLabel)
            self.gridLayout.addWidget(lengthLabel, i, 2)

            lengthValue = CustomSpinBox(self)
            lengthValue.index = i
            lengthValue.type = LENGTH 
            lengthValue.setMinimum(-99.999) 
            lengthValue.setMaximum(99.999) 
            lengthValue.setDecimals(3)
            lengthValue.setSingleStep(0.01)
            lengthValue.setStyleSheet("QDoubleSpinBox { color : red }")
            QtCore.QObject.connect(lengthValue, QtCore.SIGNAL("signalSelectType(int, int)"), \
                                    self.slotSelectType)
            QtCore.QObject.connect(lengthValue, QtCore.SIGNAL("signalDeselect()"), \
                                    self.slotDeselect)
            QtCore.QObject.connect(lengthValue, QtCore.SIGNAL("valueChangedPlus(int, int, double)"), \
                                    self.updateZMatrix)
            self.gridLayout.addWidget(lengthValue, i, 3)
            self.lengthValues.append(lengthValue)

            if i == 1:
                continue

            angleLabel = CustomComboBox(self)
            angleLabel.index = i
            angleLabel.type = ANGLE
            QtCore.QObject.connect(angleLabel, QtCore.SIGNAL("activatedPlus(int, int)"), \
                                    self.slotUpdateAngle)
            QtCore.QObject.connect(angleLabel, QtCore.SIGNAL("highlightedPlus(int, int, int)"), \
                                    self.slotHighlight)
            QtCore.QObject.connect(angleLabel, QtCore.SIGNAL("signalSelectType(int, int)"), \
                                    self.slotSelectType)
            QtCore.QObject.connect(angleLabel, QtCore.SIGNAL("signalDeselect()"), \
                                    self.slotDeselect)
            self.gridLayout.addWidget(angleLabel, i, 4)
            self.angleLabels.append(angleLabel)

            angleValue = CustomSpinBox(self)
            angleValue.index = i
            angleValue.type = ANGLE
            angleValue.setMinimum(-180.00)
            angleValue.setMaximum(180.00)
            angleValue.setDecimals(2)
            angleValue.setSingleStep(0.1)
            angleValue.setStyleSheet("QDoubleSpinBox { color : green }")
            QtCore.QObject.connect(angleValue, QtCore.SIGNAL("signalSelectType(int, int)"), \
                                    self.slotSelectType)
            QtCore.QObject.connect(angleValue, QtCore.SIGNAL("signalDeselect()"), \
                                    self.slotDeselect)
            self.gridLayout.addWidget(angleValue, i, 5)
            self.angleValues.append(angleValue)

            if i == 2:
                continue

            torsionLabel = CustomComboBox(self)
            torsionLabel.index = i
            torsionLabel.type = TORSION
            QtCore.QObject.connect(torsionLabel, QtCore.SIGNAL("activatedPlus(int, int)"), \
                                    self.slotUpdateTorsion)
            QtCore.QObject.connect(torsionLabel, QtCore.SIGNAL("highlightedPlus(int, int, int)"), \
                                    self.slotHighlight)
            QtCore.QObject.connect(torsionLabel, QtCore.SIGNAL("signalSelectType(int, int)"), \
                                    self.slotSelectType)
            QtCore.QObject.connect(torsionLabel, QtCore.SIGNAL("signalDeselect()"), \
                                    self.slotDeselect)
            self.gridLayout.addWidget(torsionLabel, i, 6)
            self.torsionLabels.append(torsionLabel)

            torsionValue = CustomSpinBox(self)
            torsionValue.index = i
            torsionValue.type = TORSION
            torsionValue.setMinimum(-180.00)
            torsionValue.setMaximum(180.00)
            torsionValue.setDecimals(2)
            torsionValue.setSingleStep(0.1)
            torsionValue.setStyleSheet("QDoubleSpinBox { color : blue } ")
            QtCore.QObject.connect(torsionValue, QtCore.SIGNAL("signalSelectType(int, int)"), \
                                    self.slotSelectType)
            QtCore.QObject.connect(torsionValue, QtCore.SIGNAL("signalDeselect()"), \
                                    self.slotDeselect)
            self.gridLayout.addWidget(torsionValue, i, 7)
            self.torsionValues.append(torsionValue)

    def setZMatrix(self, matrix):

        numnames = self.model.numnames

        for i in range(len(matrix)):
            names = numnames[:]
            if i == 0:
                continue

            self.lengthValues[i-1].setValue(matrix[i][1])
            self.lengthLabels[i-1].insertItems(0, names)
            self.lengthLabels[i-1].setCurrentIndex(matrix[i][0])

            if i == 1:
                continue

            self.angleValues[i-2].setValue(matrix[i][3])
            self.angleLabels[i-2].insertItems(0, names)
            self.angleLabels[i-2].setCurrentIndex(matrix[i][2])

            if i == 2:
                continue

            self.torsionValues[i-3].setValue(matrix[i][5])
            self.torsionLabels[i-3].insertItems(0, names)
            self.torsionLabels[i-3].setCurrentIndex(matrix[i][4])


        self.isSetup = True

    def setAtomNames(self, names):
        for i in range(len(names)):
            self.elements[i].setText(names[i])

    def setModel(self, model):
        self.model = model
        matrix = model.matrix
        self.model.updateCartesian()
        self.setup(len(matrix))
        self.setZMatrix(matrix)
        self.setAtomNames(model.names)

    def setGLWidget(self, widget):
        self.glwidget = widget

    def slotUpdateLength(self, comboIndex, index):
        if comboIndex != index:
            length, angle, torsion = self.model.updateLength(comboIndex, index)
            self.lengthValues[comboIndex - 1].setValue(length)

            if angle != -9999:
                self.angleValues[comboIndex - 2].setValue(angle)
            if torsion != -9999:
                self.torsionValues[comboIndex - 3].setValue(torsion)

    def slotUpdateAngle(self, comboIndex, index):
        if comboIndex != index:
            angle, torsion = self.model.updateAngle(comboIndex, index)
            self.angleValues[comboIndex - 2].setValue(angle)

            if torsion != -9999:
                self.torsionValues[comboIndex - 3].setValue(torsion)

    def slotUpdateTorsion(self, comboIndex, index):
        if comboIndex != index:
            torsion = self.model.updateTorsion(comboIndex, index)
            self.torsionValues[comboIndex - 3].setValue(torsion)

    def slotHighlight(self, index, type, position):
        self.glwidget.setSelected([index])
        self.glwidget.setSelectedType([position], type)

        if type == TORSION:
            self.glwidget.setSelectedType([self.model.matrix[index][0]], LENGTH)
            self.glwidget.setSelectedType([self.model.matrix[index][2]], ANGLE)
            self.glwidget.setSelectedType([position], TORSION)
        if type == ANGLE:
            self.glwidget.setSelectedType([self.model.matrix[index][0]], LENGTH)
            self.glwidget.setSelectedType([position], ANGLE)
        if type == LENGTH:
            self.glwidget.setSelectedType([position], LENGTH)

        self.glwidget.updateGL()

    def slotSelectType(self, index, type):
        self.glwidget.setSelected([index])

        if type == TORSION:
            self.glwidget.setSelectedType([self.model.matrix[index][0]], LENGTH)
            self.glwidget.setSelectedType([self.model.matrix[index][2]], ANGLE)
            self.glwidget.setSelectedType([self.model.matrix[index][4]], TORSION)
        if type == ANGLE:
            self.glwidget.setSelectedType([self.model.matrix[index][0]], LENGTH)
            self.glwidget.setSelectedType([self.model.matrix[index][2]], ANGLE)
        if type == LENGTH:
            self.glwidget.setSelectedType([self.model.matrix[index][0]], LENGTH)

        self.glwidget.updateGL()

    def slotDeselect(self):
        self.glwidget.selected = []
        self.glwidget.selectedLength = []
        self.glwidget.selectedAngle = []
        self.glwidget.selectedTorsion = []
        self.glwidget.updateGL()

    def updateZMatrix(self, index, type, value):
        if self.isSetup:
            self.model.matrix[index][type*2 + 1] = value
            self.model.updateCartesian()
            self.glwidget.updateGL()

if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    parser=ccopen(sys.argv[1])
    parser.parse()
    molecule = makeopenbabel(parser.atomcoords[0],parser.atomnos)

    window = Molecule()
    model = IntModel()
    model.setMolecule(molecule)
    window.setModel(model)

    glwidget = GLWidget()
    glwidget.obmol = molecule
    glwidget.updateGL()

    window.setGLWidget(glwidget)

    window.show()
    glwidget.show()
    sys.exit(app.exec_())
