 
# items.py -- the item class used for custom listview items
#
# Copyright (c) Adam Tenderholt, Stanford University, 2005-2006
#                               a-tenderholt@stanford.edu
#
# This program is free software; you can redistribute it and/or modify  
# it under the terms of the GNU General Public License as published by 
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version with the exceptions noted in the 
# Help dialog.

#created with the help of Qt designer and pyuic

from qt import *
from classes import *

class AOViewAOItem(QListViewItem):
    def __init__(self,ao,parent=None):
        QListViewItem.__init__(self,parent)
        
        self.ao=ao
        self.setText(0,self.ao.getString())
        
        if not qVersion() == '2.3.0':
            self.setDragEnabled(True)
            
    def compare(self,item,col,asc):
        
        if(col>0):
            print "error with item"
            
        text1=self.ao.getString()
        text2=item.ao.getString()
        
        rindex1=text1.find(')')
        rindex2=text2.find(')')
        
        val1=int(text1[1:rindex1])
        val2=int(text2[1:rindex2])
        
        if(asc):
            return val1-val2
        else:
            return val2-val1

    def key(self,col,asc):

        if not (qVersion()=='2.3.0'):
            return self.text(0)

        if (col>0):
            print "error with item"

        text=self.text(0).latin1()
        rindex=text.find(')')

        val=int(text[1:rindex])

        if not asc:
            val=99999-val
            
        return "%5i"%(val,)
        
class AOViewAtomItem(QListViewItem):
    def __init__(self,atom,parent=None):
        QListViewItem.__init__(self,parent)
        
        self.atom=atom
        self.setText(0,self.atom.getString())
        
        if not qVersion() == '2.3.0':
            self.setDragEnabled(True)
                    
    def compare(self,item,col,asc):
        
        if(col>0):
            print "error with item"
            
        text1=self.atom.getString()
        text2=item.atom.getString()
        
        rindex1=text1.find(')')
        rindex2=text2.find(')')
        
        val1=int(text1[1:rindex1])
        val2=int(text2[1:rindex2])
        
        if(asc):
            return val1-val2
        
        else:
            
            name1=text1[rindex1+2:]
            name2=text2[rindex2+2:]
            
            return QString.compare(name2,name1)*1000+val2-val1

    def key(self,col,asc):

        if(col>0):
            print "error with item"
            
        if not (qVersion()=='2.3.0'):
            return self.text(0)

        text=self.text(0).latin1()
        rindex=text.find(')')

        val=int(text[1:rindex])
        name=text[rindex+2:]

        if(asc):
            return "%5i"%(val,)
        else:
            val=99999-val
            return "%s %5s"%(name,val)
        
class FragViewItem(QListViewItem):
    def __init__(self,ao,parent=None):
        QListViewItem.__init__(self,parent)
        
        self.ao=ao
        self.setText(0,self.ao.getExtendedString())
        
